/* header file   for  GP experiment
 *   19 Jan 96
 * simplified   5 Mar 97
 * update 23 Feb 2006
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define  PRIVATE  static

#define  SP    0		/* robot commands */
#define  SM    1
#define  EP    2
#define  EM    3
#define  WP    4
#define  WM    5
#define  HITQ  6
#define  SEEQ  7
#define  INCQ  8
#define  DECQ  9
#define  OUTQ  10
#define  IFAND 11
#define  IFOR  12
#define  IFNOT 13
#define  ENDCODE 14
#define  NIL   -1

#define  MAXCELL     40000
#define  CELLSIZE    5
#define  RESERVED    5    /* low end reserved usable cell start at 5 * 5 */

#define  POP         400
#define  PLEN        40   /* initial program length > PLEN */
#define  NBEST	     40
#define	 GEN		 10   /* max generation */

#define ARMWIDTH 7

#define PAINSTEP      5
#define TIMELIMIT     100
#define PAINLIMIT     500
#define BORELIMIT     10
#define HUNTLIMIT     100
#define EMPTY         255

#define TS  36   /* no of pos of shoulder angle  90..0..270 degree step 5 */
#define TE  36   /*   elbow angle  160..0..290  */
#define TW  36   /*   wrist angle   90..0..270  */
#define DA  5    /*   step size of angle        */
#define DL 2     /* step in scanline  */

#define SX 33    /* base position */
#define SY 128
#define L1 74    /* shoulder to elbow length */
#define L2 68    /* forearm length */
#define L3 24    /* grip length */

#define IMW 250  /* size of working area 250 x 200 */
#define IMH 200
#define BACKGR  8  /* background in image */
#define OBSTAC  4  /* obstacles */
#define TARGET  2  /* target */

/* unsigned 16 bits */

#define myrandom() rand()
#define myrnd(n)   ( myrandom() % (n) )
#define mysrand(c) srand(c)

/* is terminal symbol ? */
#define  isterm(c)  ((c) == NIL || (c) < IFAND )
#define  is4arg(c)  ((c) == IFAND || (c) == IFOR)

#define  cmd(p)     cell[(p)]
#define  arg1(p)    cell[(p)+1]
#define  arg2(p)    cell[(p)+2]
#define  arg3(p)    cell[(p)+3]
#define  arg4(p)    cell[(p)+4]
#define  arg(i,p)   cell[(p)+(i)]
#define  argsize(c) (is4arg(c) ? 4 : 3)     /* number of argument of a cmd */

#define  nl()       printf("\n")
#define iabs(x)    ( ( (x) < 0 ) ? (-x) : (x) )
#define isoutb(p)  outb((p),5,5,240,190)

typedef struct { int x,y; } point;
typedef int acell;

extern acell cell[];
extern char im[IMW][IMH];

/* function prototypes */

int evalprog(int ap);
void gmove(int s, int e, int w);
int distance(point p1, point p2);
int fastscan(point p1, point p2);
void sethome(void);
void armpos(void);
void markcell(void);
int copyprog(int ap);
void reclaim(void);
void crossover(int ap1, int ap2);
int genprogn(int n, int *len);
int proglen(int ap);
void tofile(int ap, FILE *fp);
int addprog(int ap);
int extendprog(int ap);
void initcell(void);
void env0(void);
int outb(point p, int x, int y, int w, int h);
int fromfile(FILE *fp);
